package juego;

import java.awt.BorderLayout;
import java.awt.Event;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.KeyStroke;

public class Cargar {

	private JFrame jFrame = null;  //  @jve:decl-index=0:visual-constraint="10,390"
	private JPanel jContentPane = null;
	private JMenuBar jJMenuBar = null;
	private JMenu fileMenu = null;
	private JMenuItem exitMenuItem = null;
	private JMenuItem saveMenuItem = null;
	private JScrollPane jScrollPane = null;
	private JTextArea jTextArea = null;
	private JMenuItem openMenuItem;
	private BufferedReader cfg = null;

	public Cargar() throws IOException
	{
		getJFrame().setVisible(true);
		
		File f = new File("ai.cfg");
	    if(!f.exists()) f.createNewFile();
	    f = null;
		cfg = new BufferedReader(new FileReader("ai.cfg"));

		String fn;
		while ((fn = cfg.readLine()) != null)
			if (jTextArea.getText().equals(""))
				jTextArea.setText(fn);
			else
				jTextArea.setText(jTextArea.getText() + "\n" + fn);
	}
	
	protected void open() throws IOException
	{
	    JFileChooser chooser = new JFileChooser();
	    int returnVal = chooser.showOpenDialog(this.getJFrame());
	    if(returnVal != JFileChooser.APPROVE_OPTION)
	    	return;

		if (jTextArea.getText().equals(""))
			jTextArea.setText(chooser.getSelectedFile().getCanonicalPath());
		else
			jTextArea.setText(jTextArea.getText() + "\n" + chooser.getSelectedFile().getCanonicalPath());
	}
	
	protected void save() throws IOException
	{
        BufferedWriter out = new BufferedWriter(new FileWriter("ai.cfg"));
        out.write(jTextArea.getText());
        out.close();
	}
	
	public JFrame getJFrame() {
		if (jFrame == null) {
			jFrame = new JFrame();
			jFrame.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
			jFrame.setJMenuBar(getJJMenuBar());
			jFrame.setSize(481, 280);
			jFrame.setContentPane(getJContentPane());
			jFrame.setTitle("Instalacin de estrategias");
		}
		return jFrame;
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJScrollPane(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

	private JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new JMenuBar();
			jJMenuBar.add(getFileMenu());
		}
		return jJMenuBar;
	}

	private JMenu getFileMenu() {
		if (fileMenu == null) {
			fileMenu = new JMenu();
			fileMenu.setText("Archivo");
			fileMenu.add(getOpenMenuItem());
			fileMenu.add(getSaveMenuItem());
			fileMenu.add(getExitMenuItem());
		}
		return fileMenu;
	}

	private JMenuItem getExitMenuItem() {
		if (exitMenuItem == null) {
			exitMenuItem = new JMenuItem();
			exitMenuItem.setText("Salir");
			exitMenuItem.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					getJFrame().setVisible(false);
				}
			});
		}
		return exitMenuItem;
	}

	private JMenuItem getSaveMenuItem() {
		if (saveMenuItem == null) {
			saveMenuItem = new JMenuItem();
			saveMenuItem.setText("Guardar");
			saveMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,
					Event.CTRL_MASK, true));			
			saveMenuItem.addActionListener(new ActionListener()
					{
						public void actionPerformed(ActionEvent e)
						{
								try {
									save();
								} catch (IOException e1) {
									e1.printStackTrace();
								}
						}
					});
		}
		return saveMenuItem;
	}

	protected JMenuItem getOpenMenuItem()
	{
		if (openMenuItem == null)
		{
			openMenuItem = new JMenuItem();
			openMenuItem.setText("Abrir");
			openMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,
					Event.CTRL_MASK, true));
			openMenuItem.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
						try {
							open();
						} catch (IOException e1) {
							e1.printStackTrace();
						}
				}
			});
		}
		return openMenuItem;
	}
	
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane.setViewportView(getJTextArea());
		}
		return jScrollPane;
	}

	private JTextArea getJTextArea() {
		if (jTextArea == null) {
			jTextArea = new JTextArea();
			jTextArea.setLineWrap(true);
		}
		return jTextArea;
	}
}
