package juego.editar;

import java.util.Collections;

import stratego.Tablero;
import stratego.Movimiento;
import stratego.Pieza;
import stratego.Puntero;



public class EditarTablero extends Tablero implements EditarControles
{
	private Editar view = null;

	public EditarTablero(Editar v)
	{
		view = v;
		for (int i=0;i<40;i++)
		for (Pieza p: tray)
			if (p.getColor() == 1) 
			{
				tray.remove(p);
				break;
			}
		
		view.registerEngine(this);
	}
	
	public boolean move(Movimiento m)
	{		
		//Recuerde, las piezas de bandejas que estn en -1, no funcionan.
		if (m.getFrom().getY()>3)
			return false;
		if (m.getTo().getY()>3)
			m = new Movimiento(m.getPiece(), m.getFrom(), IN_TRAY);
		
		if (m.getTo().equals(IN_TRAY))
			return remove(m.getFrom());
		else if (getPiece(m.getTo()) != null)
			return false;
		else if (m.getFrom().equals(IN_TRAY))
			return add(m.getPiece(), m.getTo());
		else 
		{
			setPiece(m.getPiece(), m.getTo());
			setPiece(null, m.getFrom());
			return true;
		}
	}
	
	public boolean add(Pieza p, Puntero s)
	{
		if (getPiece(s) == null)
		{
			setPiece(p, s);
			tray.remove(p);
			Collections.sort(tray);
			return true;
		}
		return false;
	}
	
	public boolean remove(Puntero s)
	{
		if (s.equals(IN_TRAY))
			return false;
		else
		{
			tray.add(getPiece(s));
			setPiece(null, s);
			Collections.sort(tray);
			return true;
		}
	}
	
	public void clear()
	{
		super.clear();
		setTopColor(0);
	}
}
