package servidor;

import java.util.ArrayList;
import java.util.Scanner;

public class ServidorControlador
{
	private ArrayList<Controlador> controllers = new ArrayList<Controlador>();
	private Controlador localController = null;
	private Servidor s = null;
	private int port;
	
	public ServidorControlador(int p)
	{
		port = p;
	}
	
	public Servidor getServer()
	{
		return s;
	}
	
	public void setServer(Servidor srv)
	{
		s = srv;
	}
	
	public void start()
	{
		localController = new Controlador(this, 0);
		localController.connect(new Scanner(System.in), System.out);
		controllers.add(localController);
		s = new Servidor(port, this);
		localController.start();
	}
	
	public void add(Controlador c)
	{
		controllers.add(c);
	}
	
	public void disconnectAll()
	{
		print("Desconectando todas las conexiones remotas...");
		for (int i=0;i<controllers.size();)
		{
			if (controllers.get(i) != localController)
			{
				controllers.get(i).print("Desconectado por el servidor.");
				controllers.get(i).disconnect();
				controllers.remove(i);
			}
			else
			{
				i++;
			}
		}
	}
	
	public void remove(Controlador r)
	{
		controllers.remove(r);
	}
	
	public void exit()
	{
		s.close();
		System.exit(0);
	}
	
	public String getRemote(Controlador c)
	{
		if (c == localController)
		{
			String ret = "Conectado a " + (controllers.size()-1) + " controladores remotos:";
			for (int i=0;i<controllers.size();i++)
			{
				if (controllers.get(i) != localController)
				{
					ret += "\n" + i
							 + ". " + controllers.get(i).getPrivilege()
							 + " "  + controllers.get(i).getRemote().getIP()
					         + ":"  + controllers.get(i).getRemote().getPort();
				}
			}
			return ret;
		}
		else
		{
			return "Conectado como controlador remoto\n" +
					"en puerto " + c.getRemote().getPort()
					+ " desde " + c.getRemote().getIP();
		}
	}

	public void print(String e)
	{
		for (int i=0;i<controllers.size();i++)
			controllers.get(i).print(e);
	}
}
